//! A logger abstraction for the CI broker.

use std::sync::Mutex;

use slog::{info, o, Drain};

pub struct Logger {
    root: slog::Logger,
}

impl Default for Logger {
    fn default() -> Self {
        Self {
            root: slog::Logger::root(
                Mutex::new(slog_json::Json::default(std::io::stderr())).map(slog::Fuse),
                o!(),
            ),
        }
    }
}

impl Logger {
    pub fn start_cib(&self) {
        info!(&self.root, "CI broker starts");
    }

    pub fn end_cib_successfully(&self) {
        info!(&self.root, "CI broker ends successfully");
    }

    pub fn end_cib_in_error(&self) {
        info!(&self.root, "CI broker ends in unrecoverable error");
    }
}
